/***
* CHARACTER [] ColorSplit(cColor)
*
* CHARACTER color_to_split - The color to split. Optional, defaults
*                            to current color.
*
* RETURN - An array with the split colors
*
* Split color_to_split into 5 colors and save return in array.
*/

#include "Commands.ch"              // For DEFAULT TO UDC

FUNCTION ColorSplit(cColor)

LOCAL nColor, nNextComma, aColors[5]

  DEFAULT cColor TO SetColor()
  FOR nColor := 1 TO 4
    nNextComma := At(",", cColor)
    aColors[nColor] := substr(cColor, 1, nNextComma - 1)
    cColor := SubStr(cColor, nNextComma + 1)
  NEXT

  aColors[5] := cColor

RETURN aColors
