Listing 3 -- The YESNO UDF

FUNCTION yesno
PARAMETERS a_mess
PRIVATE m_len, s_col, rvalue

m_len = len(a_mess)        &&  length of our message

IF m_len > 65              &&  trim if too long
  a_mess = left(a_mess,65)
ENDIF

IF m_len < 17              &&  message is too short
  a_mess = replicate(chr(32),int((17-m_len)/2)) +;
           a_mess
  m_len = 17
ENDIF

s_col = int((75-m_len)/2)  &&  starting wincol

DEFINE WINDOW pt_yesno FROM 08,s_col ;
                       TO 14,s_col+m_len+5 ;
                       DOUBLE
DEFINE MENU pt_yesno
DEFINE PAD pt_yes OF pt_yesno ;
       PROMPT ' <Yes> ' ;
       AT 3,int((m_len-12)/2)
DEFINE PAD pt_no OF pt_yesno ;
       PROMPT ' <No> ' ;
       AT 3,int((m_len+9)/2)

ON SELECTION PAD pt_yes OF pt_yesno ;
                 DEACTIVATE MENU
ON SELECTION PAD pt_no OF pt_yesno ;
                 DEACTIVATE MENU

ACTIVATE WINDOW pt_yesno
@ 01,02 SAY a_mess
ACTIVATE MENU pt_yesno     &&  our wait state

rvalue = iif(prompt() = ' <Yes> ', .t., .f.)
RELEASE MENU pt_yesno
RELEASE WINDOW pt_yesno

RETURN(rvalue)

*******
