/***
* Mousesup.prg
*
* Support functions for mouse support. Mouse.ch maps Clipper functions
* that mess with the mouse, or that write to the screen, to these
* routines.
*/

// Hot spot code in here
// Scroll bar code in here also

// QOut / DevOut ??? DevOutPict(xpr, pic, color)
// DispBox QQOut, __XSaveScreen(), __XRestScreen()
// SetCursor() ??? Scroll has an extra parameter

FUNCTION MScroll(nTop, nLeft, nBottom, nRight, nDirection)

LOCAL lSaveMouse := SetMouse(.F.)

  Scroll(nTop, nLeft, nBottom, nRight, nDirection)
  SetMouse(lSaveMouse)

RETURN NIL


FUNCTION MSetMode(nRows, nCols)

LOCAL lSaveMouse := SetMouse(.F.)
LOCAL lSaveResult

  lSaveResult := SetMode(nRows, nCols)
  MouseInit()
  SetMouse(lSaveMouse)

RETURN lSaveResult


FUNCTION MSaveScreen(nTop, nLeft, nBottom, nRight)

LOCAL lSaveResult
LOCAL lSaveMouse := SetMouse(.F.)

  lSaveResult := SaveScreen(nTop, nLeft, nBottom, nRight)
  SetMouse(lSaveMouse)

RETURN lSaveResult


FUNCTION MRestScreen(nTop, nLeft, nBottom, nRight, cSavedScreen)

LOCAL lSaveMouse := SetMouse(.F.)

  RestScreen(nTop, nLeft, nBottom, nRight, cSavedScreen)
  SetMouse(lSaveMouse)

RETURN NIL

// > 1 param problem ...

FUNCTION MQout(cString)

LOCAL lSaveMouse := SetMouse(.F.)

  QOut(cString)
  SetMouse(lSaveMouse)

RETURN NIL


FUNCTION MDevOut(cString, cColor)

LOCAL lSaveMouse := SetMouse(.F.)

  DevOut(cString, cColor)
  MouseOn(lSaveMouse)

RETURN NIL
